require ("ui.login.SelectServer.ServerItemNode")
--require("common.BaseUI")
AllServerView = AllServerView or BaseClass(LoginBaseUI)

local viewSize = CCSizeMake(885, 600)  --界面大小
local cellSize = VisibleRect:getScaleSize(CCSizeMake(206, 68)) --tableview的cell大小
local detailCellSize = VisibleRect:getScaleSize(CCSizeMake(585, 85))
local tableViewBgSize = VisibleRect:getScaleSize(CCSizeMake(220, 430)) --tableview背景的大小

local detailNodeBgSize = VisibleRect:getScaleSize(CCSizeMake(585, 430))
local scrollViewContentSize = VisibleRect:getScaleSize(CCSizeMake(630, 500)) --scrollview的Container大小
local serverItemSize = VisibleRect:getScaleSize(CCSizeMake(285, 68)) --scrollview中的item大小

local serverPerArea = 10 --每个区服务器的个数
local itemsPerLine = 2 --每行两列

local CELL_TAG = 100

local kTableCellSizeForIndex 		= 0
local kCellSizeForTable 			= 1
local kTableCellAtIndex 			= 2
local kNumberOfCellsInTableView 	= 3

function AllServerView:__init()
	self.viewName = "AllServerView"	
	self.curPage = 1			 
	self.serverMgr = LoginWorld.Instance:getServerMgr()	
	
	self:createRootNode()	
	self:createRecommendServer()    --推荐登录
	self:createRecentServer()       --最近登录
	self:createServerDetail()	
	self:createServerArea()	
	
	--self:createUI()		
	self:createCloseBtn()
end

function AllServerView:__delete()
	if self.selectFrame then 
		self.selectFrame:release()
		self.selectFrame = nil
	end
end

function AllServerView:createRootNode()
	local title = createSpriteWithFrameName(RES("ui_font_xzfwq.png"))
	self:createVipFrame(viewSize, title)	



	local bg = CCScale9Sprite:create("loginUi/login/selectRoleBg.jpg")		
	self.rootNode:addChild(bg,-999)-- -,999
	VisibleRect:relativePosition(bg, self.rootNode, LAYOUT_CENTER)
	G_setBigScale(bg)
	self:makeMeCenter()


	local bgImg = createSpriteWithFrameName(RES("ui_serverlist_bg.png"))
	self.rootNode:addChild(bgImg)
	VisibleRect:relativePosition(bgImg, self.rootNode, LAYOUT_CENTER, ccp(0, 10))
	
	--左边背景
	self.leftNodeBg = createScale9SpriteWithFrameNameAndSize(RES("common_neibiankuang.png"), tableViewBgSize,CCRectMake(15,15,1,1))
	self.rootNode:addChild(self.leftNodeBg)
	VisibleRect:relativePosition(self.leftNodeBg, self.rootNode, LAYOUT_LEFT_INSIDE+LAYOUT_TOP_INSIDE, ccp(30, -55)) -- 35, -55
	
	--右边背景
	self.rightNodeBg = createScale9SpriteWithFrameNameAndSize(RES("common_neibiankuang.png"), detailNodeBgSize,CCRectMake(15,15,1,1))
	self.rootNode:addChild(self.rightNodeBg)
	VisibleRect:relativePosition(self.rightNodeBg, self.leftNodeBg, LAYOUT_RIGHT_OUTSIDE+LAYOUT_TOP_INSIDE, ccp(8, 0))
		


	-- 分割线 -->变成 底板
	local line = createSpriteWithFrameName(RES("ui_serverlist_bottom_bar.png"))
	self.rootNode:addChild(line)
	VisibleRect:relativePosition(line, self:getContentNode(), LAYOUT_CENTER_X)
	VisibleRect:relativePosition(line, self.rightNodeBg, LAYOUT_BOTTOM_OUTSIDE, ccp(0,-4))
end				

-- 推荐登录
function AllServerView:createRecommendServer()
	local item = ServerItemNode.New(ServerItemType.ServerRecommend, false)	
	item:setName(Config.LoginWords[8504])
	local node = item:getRootNode()
	if node then 		
		local size = node:getContentSize()
		self.recommendBtn = createButtonWithFramename(RES("ui_serverlist_btn_select.png"), nil, size)
		self.recommendBtn:setTitleString(node)	
		self.rootNode:addChild(self.recommendBtn)
		VisibleRect:relativePosition(self.recommendBtn, self.leftNodeBg, LAYOUT_CENTER_X+LAYOUT_TOP_INSIDE)
		self:addSelectFrametoParent(self.recommendBtn)
		
		local recommendServerClick = function ()	
			if self.curPage ~= 1 then 
				self.curPage = 1			
				self:addSelectFrametoParent(self.recommendBtn)						
				self:updateServerList()
			end
		end
		self.recommendBtn:addTargetWithActionForControlEvents(recommendServerClick, CCControlEventTouchDown)
	end
end

-- 选中框， 单例
function AllServerView:getSelectFrame(size)
	if not self.selectFrame then 
		self.selectFrame = createScale9SpriteWithFrameNameAndSize(RES("ui_serverlist_btn_cover.png"), size)
		self.selectFrame:retain()
	end
	self.selectFrame:setContentSize(size)
	return self.selectFrame
end

-- 把选中框加到选中的parent上
function AllServerView:addSelectFrametoParent(parent)
	if parent then
		local size = parent:getContentSize()
		local selectFrame = self:getSelectFrame(CCSizeMake(size.width - 20, size.height -20))	
		if selectFrame and selectFrame:getParent()~=parent then 			
			selectFrame:removeFromParentAndCleanup(true)
			parent:addChild(selectFrame)
			VisibleRect:relativePosition(selectFrame, parent, LAYOUT_CENTER)							
		end	
	end
end

-- 最近登录
function AllServerView:createRecentServer()
	self.recentLabel = createSpriteWithFrameName(RES("server_lastTimeLogin.png"))
	self.rootNode:addChild(self.recentLabel)
	VisibleRect:relativePosition(self.recentLabel, self.recommendBtn, LAYOUT_BOTTOM_OUTSIDE+LAYOUT_CENTER_X, ccp(0, -12))
	
	--local serverStr = self.serverMgr:getRecentServers()
	--self:updateRecentServer(serverStr)
end

function AllServerView:updateRecentServer(serverId)
	local bNeedUpdate = false

	--if serverStr and string.len(serverStr)>0 then 
    if serverId and string.len(serverId)>0 then
        
        local recentId = string.split(serverId, "&")
		local count = table.size(recentId)

	
		if self.noRecentLogin then 
			self.noRecentLogin:getRootNode():removeFromParentAndCleanup(true)
			self.noRecentLogin = nil
		end				
		
		local existCount = 0
		self.array = {}
		for i=1, count do 		
			local server = recentId[i]

			--local info = string.split(server, ",")
			local id_start,_ = string.find(server, "=")
			if not id_start then 
				self.serverMgr:removeRecentServer(nil, nil)  -- 读取错误， 清空保存最近服务器
				return
			end
			local id = string.sub(server, id_start+1, -1)

			local serverObj = self.serverMgr:getServerById(id)
									
			if serverObj then 	
				existCount = existCount + 1
				self.array[i] = serverObj		
				local item = ServerItemNode.New(ServerItemType.ServerRecent, false)	
				if not item:getRootNode() then 
					return
				end
				item:getRootNode():setTag(100)
				item:setServerInfo(serverObj)				
				local size = item:getRootNode():getContentSize()				
				local btn = self.rootNode:getChildByTag(200+i)				
				if not btn then 
					btn = createButtonWithFramename(RES("ui_serverlist_btn_select.png"), nil, size)
					btn:setTag(200+i)					
					self.rootNode:addChild(btn)
					VisibleRect:relativePosition(btn, self.recentLabel, LAYOUT_BOTTOM_OUTSIDE+LAYOUT_CENTER_X, ccp(0, -(existCount-1)*(size.height+15)-10))						
					
					local function recentCb()						
						self.serverMgr:handleServerLogin(self.array[i])
					end
					btn:addTargetWithActionForControlEvents(recentCb, CCControlEventTouchDown)	
				else
					btn = tolua.cast(btn, "CCControlButton")
				end	
								
				btn:removeChildByTag(100, true)
				btn:setTitleString(item:getRootNode()) 

			else									
				--self.serverMgr:removeRecentServer(ip, port)
				self.serverMgr:removeRecentServer(id)			
				bNeedUpdate = true
				break
			end
		end

        --CCLuaLog(serverStr)

		--[[local recentServers = string.split(serverStr, "&")
		local count = table.size(recentServers)
	
		if self.noRecentLogin then 
			self.noRecentLogin:getRootNode():removeFromParentAndCleanup(true)
			self.noRecentLogin = nil
		end				
		
		local existCount = 0
		self.array = {}
		for i=1, count do 		
			local server = recentServers[i]
			local info = string.split(server, ",")
			local ip_start,_ = string.find(info[1], "=")
			if not ip_start then 
				self.serverMgr:removeRecentServer(nil, nil)  -- 读取错误， 清空保存最近服务器
				return
			end
			local ip = string.sub(info[1], ip_start+1, -1)
			local port_start, _ = string.find(info[2], "=")
			if not port_start then 
				self.serverMgr:removeRecentServer(nil, nil)  -- 读取错误， 清空保存最近服务器
				return
			end
			local port = string.sub(info[2], port_start+1, -1)

			local serverObj = self.serverMgr:getServer(ip, port)
						
			
			if serverObj then 	
				existCount = existCount + 1
				self.array[i] = serverObj		
				local item = ServerItemNode.New(ServerItemType.ServerRecent, false)	
				if not item:getRootNode() then 
					return
				end
				item:getRootNode():setTag(100)
				item:setServerInfo(serverObj)				
				local size = item:getRootNode():getContentSize()				
				local btn = self.rootNode:getChildByTag(200+i)				
				if not btn then 
					btn = createButtonWithFramename(RES("ui_serverlist_btn_select.png"), nil, size)
					btn:setTag(200+i)					
					self.rootNode:addChild(btn)
					VisibleRect:relativePosition(btn, self.recentLabel, LAYOUT_BOTTOM_OUTSIDE+LAYOUT_CENTER_X, ccp(0, -(existCount-1)*(size.height+15)-10))						
					
					local recentCb = function ()						
						self.serverMgr:handleServerLogin(self.array[i])
					end
					btn:addTargetWithActionForControlEvents(recentCb, CCControlEventTouchDown)	
				else
					btn = tolua.cast(btn, "CCControlButton")
				end	
								
				btn:removeChildByTag(100, true)
				btn:setTitleString(item:getRootNode()) 

			else									
				self.serverMgr:removeRecentServer(ip, port)			
				bNeedUpdate = true
				break
			end
		end]]
	else
		if not self.noRecentLogin then 
			self.noRecentLogin = ServerItemNode.New(ServerItemType.ServerRecommend, true)	
			self.rootNode:addChild(self.noRecentLogin:getRootNode())
			self.noRecentLogin:setName(Config.LoginWords[359])
			VisibleRect:relativePosition(self.noRecentLogin:getRootNode(), self.recentLabel, LAYOUT_BOTTOM_OUTSIDE+LAYOUT_CENTER_X, ccp(0, -10))
		end
	end
	
	if bNeedUpdate then 
		self:update()
	end
end


function AllServerView:onEnter()
	--每次进入必须先断开连接
	local loginMgr = LoginWorld.Instance:getLoginManager()
	loginMgr:getConnectionService():slientDisConnect()
	--更新界面
	self:update()

	if LoginGuajiMgr then
		LoginGuajiMgr:doStep("AllServerView")
	end
end	

function AllServerView:createCloseBtn()
	local backFunction = function ()	
		SFLoginManager:getInstance():logout()
		GlobalEventSystem:Fire(GameEvent.EventShowGetServerListHUD)
		self:close()
	end
	
	self:createVipFrameCloseBtn(ClosebtnType.Back,backFunction)
end

function AllServerView:create()
	return AllServerView.New()
end	


-- 服务器分区 例如：1-3区  4-6区
function AllServerView:createServerArea()
	-- 服务器大区
	local bigAreaSize = CCSizeMake(cellSize.width*4, cellSize.height)
	self.serverAreaScrollView = createScrollViewWithSize(bigAreaSize)
	self.serverAreaScrollView:setDirection(kSFScrollViewDirectionHorizontal)
	self.serverAreaScrollView:setPageEnable(false)
	self.rootNode:addChild(self.serverAreaScrollView)		
	VisibleRect:relativePosition(self.serverAreaScrollView, self.rootNode, LAYOUT_CENTER_X)
	VisibleRect:relativePosition(self.serverAreaScrollView, self.rightNodeBg, LAYOUT_BOTTOM_OUTSIDE, ccp(0, -20))		
	self.containerNode = CCNode:create()
	self.containerNode:setContentSize(bigAreaSize)	
	self.serverAreaScrollView:setContainer(self.containerNode)
	
	--左右箭头
	self.leftArrow = createSpriteWithFrameName(RES("login_knight_arrow.png"))
	self.leftArrow:setRotation(180)
	self.rootNode:addChild(self.leftArrow)
	self.leftArrow:setVisible(false)
	VisibleRect:relativePosition(self.leftArrow, self.serverAreaScrollView, LAYOUT_LEFT_INSIDE+LAYOUT_CENTER_Y, ccp(0, 0))		
	self.rightArrow = createSpriteWithFrameName(RES("login_knight_arrow.png"))	
	self.rootNode:addChild(self.rightArrow)
	VisibleRect:relativePosition(self.rightArrow, self.serverAreaScrollView, LAYOUT_RIGHT_INSIDE+LAYOUT_CENTER_Y, ccp(0, 0))--LAYOUT_RIGHT_OUTSIDE
	--gAddColorLayer(self.serverAreaScrollView)		
		
	local scrollHandler = function(view, eventType, x, y)		
		if (eventType == 4) then  --kScrollViewTouchEnd								
			local childCnt = self.containerNode:getChildrenCount()
			for i=1, childCnt do 			
				if self:isTouchInBigArea(i, x, y) then 
					if self.curPage ~= i+1 then
						local item = self.containerNode:getChildByTag(i)
						self:addSelectFrametoParent(item)										
						self.curPage = i+1						
						self:updateServerList()		
					end
					break
				end
			end
		elseif (eventType == 5 or eventType==3) then 
			local offset = self.serverAreaScrollView:getContentOffset()	
			local deviation = -7	--偏差值
			if offset.x >= deviation then
				-- self.leftArrow:setVisible(false)
			else
				-- self.leftArrow:setVisible(true)
			end
						
			local containerSize = self.containerNode:getContentSize()	
			local childCnt = self.containerNode:getChildrenCount()
			if cellSize.width*childCnt >= bigAreaSize.width then 							
				if -offset.x < containerSize.width - bigAreaSize.width + deviation then 				
					-- self.rightArrow:setVisible(true)
				else	
					-- self.rightArrow:setVisible(false)
				end		
			else
				-- self.rightArrow:setVisible(false)
			end
		end
		return 1			
	end
	self.serverAreaScrollView:setHandler(scrollHandler)
end

function AllServerView:isTouchInBigArea(index, x, y)
	local point = self.serverAreaScrollView:convertToWorldSpace(ccp(x, y))	
	point = self.containerNode:convertToNodeSpace(point)
	local item = self.containerNode:getChildByTag(index)
	if item then 
		local rect = item:boundingBox()
		if rect:containsPoint(point) then 
			return true
		end
	end
	return false
end

-- 更新服务器大区信息
function AllServerView:updateBigArea(count)
	if count and type(count) == "number" then 
		self:updateContentSize(count)
		
		local viewSize = self.serverAreaScrollView:getViewSize()
		local newContentSize = self.containerNode:getContentSize()
		local offset = self.serverAreaScrollView:getContentOffset()									
		if -offset.x < newContentSize.width - viewSize.width then 
			-- self.rightArrow:setVisible(true)
		else	
			-- self.rightArrow:setVisible(false)
		end		
	
		local oldCount = self.containerNode:getChildrenCount()
		if oldCount >= count then 
			for i=count, oldCount do 
				self.containerNode:removeChildByTag(i, true)
			end
		end
		for i=1, count do 
			if not self.containerNode:getChildByTag(i) then 
				local bigAreaItem = self:createCellItem(i)
				bigAreaItem:setTag(i)
				self.containerNode:addChild(bigAreaItem)
				VisibleRect:relativePosition(bigAreaItem, self.containerNode, LAYOUT_CENTER_Y+LAYOUT_LEFT_INSIDE, ccp((i-1)*cellSize.width, 0))			
			end
		end			
	end
end

function AllServerView:updateContentSize(count)
	local containerSize = self.containerNode:getContentSize()		
	if containerSize.width < count*cellSize.width then 
		self.containerNode:setContentSize(CCSizeMake(count*cellSize.width, cellSize.height))
	else			
		local viewSize = self.serverAreaScrollView:getViewSize()	
		if viewSize.width > containerSize.width then 
			self.containerNode:setContentSize(viewSize)
		else
			self.containerNode:setContentSize(containerSize)
		end
	end			
	self.serverAreaScrollView:updateInset()
end

function AllServerView:createCellItem(index)
	local item = CCNode:create()
	item:setContentSize(cellSize)
	--cell背景
	local cellBg = createScale9SpriteWithFrameNameAndSize(RES("ui_serverlist_btn_select.png"), cellSize)
	item:addChild(cellBg)
	VisibleRect:relativePosition(cellBg, item, LAYOUT_CENTER)
	
	local lastStr = nil	
	local serverCount = self:getServerCount()
	local count = math.modf((serverCount-1)/serverPerArea)+1 	
			
	local firstStr = string.format("%d", (index-1)*serverPerArea+1)
	if (index*serverPerArea) > serverCount then  
		lastStr =  string.format("%d", serverCount)
	else
		lastStr =  string.format("%d", index*serverPerArea)
	end			
	local serverInfo = firstStr .. "-" .. lastStr.. Config.LoginWords[8500]	
		
	local strLabel = createLabelWithStringFontSizeColorAndDimension(serverInfo, "Arial", FSIZE("Size5"), FCOLOR("ColorWhite1"))	
	item:addChild(strLabel)
	VisibleRect:relativePosition(strLabel, item, LAYOUT_CENTER)
	
	return item
end

function AllServerView:createDetailCellItem(index)
	local totalPage = math.modf((self:getServerCount()-1)/serverPerArea)+1
	local serverCount = self:getServerCount()	
	
	local item = CCNode:create()
	item:setContentSize(detailCellSize)		
	
	local pageCount = serverPerArea
	local serverIndex = -1
	if self.curPage == 1 then   --推荐服务器	
		local recommendList = self.serverMgr:getRecommendServerList()
		pageCount = table.size(recommendList)	
		if recommendList[index*2+1] and recommendList[index*2+1].getShowOrders then
			serverIndex = recommendList[index*2+1]:getShowOrders()
		end			
	else		
		if (serverCount-(self.curPage-1)*serverPerArea) < 0 then 
			pageCount = serverCount-(self.curPage-2)*serverPerArea
		end
		serverIndex = index*2+(self.curPage-2)*serverPerArea+1
	end
				
	local t, tt = math.modf(pageCount/2)
	local bSingle = false	
	if index== t and (self.curPage==(totalPage+1) or self.curPage==1)then
		if tt ~= 0 then    --单数		
			bSingle = true					
		end			
	end				
	
	local server = self.serverMgr:getServerByShowOrder(serverIndex)

	if server==nil then 
		return item
	end
	
	local leftItem = ServerItemNode.New(ServerItemType.ServerList, true)	
	leftItem:setServerInfo(server)		
	leftItem:getRootNode():setTag(1)
	item:addChild(leftItem:getRootNode())
	VisibleRect:relativePosition(leftItem:getRootNode(), item, LAYOUT_LEFT_INSIDE+LAYOUT_TOP_INSIDE)
	if bSingle == false	then
		if self.curPage ~= 1 then 
			server = self.serverMgr:getServerByShowOrder(serverIndex+1)
		else
			local recommendList = self.serverMgr:getRecommendServerList()
			serverIndex = recommendList[index*2+2]:getShowOrders()
			server = self.serverMgr:getServerByShowOrder(serverIndex)
		end
		rightItem = ServerItemNode.New(ServerItemType.ServerList, true)
		rightItem:setServerInfo(server)		
		item:addChild(rightItem:getRootNode())
		rightItem:getRootNode():setTag(2)
		VisibleRect:relativePosition(rightItem:getRootNode(), item, LAYOUT_RIGHT_INSIDE+LAYOUT_TOP_INSIDE)
	end
	item:setTag(CELL_TAG)
	return item
end

function AllServerView:createServerDetail()
	local function serverDetailHandler(eventType,tableP,index,data)
		local data = tolua.cast(data,"SFTableData")
		local tableP = tolua.cast(tableP, "SFTableView")
				
		if eventType == kTableCellSizeForIndex then
			data:setSize(CCSizeMake(detailCellSize.width, tableViewBgSize.height/5))
			return 1
		elseif eventType == kCellSizeForTable then
			data:setSize(VisibleRect:getScaleSize(CCSizeMake(detailCellSize.width, tableViewBgSize.height/5)))
			return 1
		elseif eventType == kTableCellAtIndex then
			local tableCell = tableP:dequeueCell(index)
			if tableCell == nil then
				local cell = SFTableViewCell:create()
				cell:setContentSize(CCSizeMake(detailCellSize.width, tableViewBgSize.height/5))
				local item = self:createDetailCellItem(index)
				cell:addChild(item)
				cell:setIndex(index+1)
				data:setCell(cell)
			else
				tableCell:removeAllChildrenWithCleanup(true)
				tableCell:setContentSize(CCSizeMake(detailCellSize.width, tableViewBgSize.height/5))
				tableCell:setIndex(index+1)
				local item = self:createDetailCellItem(index)
				tableCell:addChild(item)
				data:setCell(tableCell)
			end
			return 1
		elseif eventType == kNumberOfCellsInTableView then
			local itemCount = self:calculateItemCnt()			
			data:setIndex(itemCount)
			return 1
		end
	end
	
	--点击事件
	local tableDelegate = function (tableP,cell,x,y)	
		cell = tolua.cast(cell,"SFTableViewCell")
		local item = cell:getChildByTag(CELL_TAG)	
		if item == nil then 
			return
		end
		local cellIndex = cell:getIndex()	
		local count = item:getChildren():count()
		local touchPoint = ccp(x,y)		
		for i = 1, count do 		
			local rect = item:getChildByTag(i):boundingBox()
			if rect:containsPoint(touchPoint) then												
				local realIndex = -1
				if self.curPage == 1 then   --推荐服务器
					local recommendList = self.serverMgr:getRecommendServerList()
					if recommendList[(cellIndex-1)*2+i] and recommendList[(cellIndex-1)*2+i].getShowOrders then
						realIndex = recommendList[(cellIndex-1)*2+i]:getShowOrders()	
					end																			
				else							
					realIndex = (self.curPage-2)*serverPerArea+((cellIndex-1)*2+i)				
				end
																				
				local server = self.serverMgr:getServerByShowOrder(realIndex)	
																						
				self.serverMgr:handleServerLogin(server)
				break
			end
		end
	end
	
	--创建tableview
	self.serverDetailTable = createTableView(serverDetailHandler, VisibleRect:getScaleSize(CCSizeMake(detailCellSize.width, tableViewBgSize.height)))
	self.serverDetailTable:setTableViewHandler(tableDelegate)
	self.serverDetailTable:reloadData()
	self.serverDetailTable:scroll2Cell(0, false)  --回滚到第一个cell
	self.rootNode:addChild(self.serverDetailTable)
	VisibleRect:relativePosition(self.serverDetailTable, self.rightNodeBg, LAYOUT_CENTER)	
end

function AllServerView:calculateItemCnt()
	local itemCount = 5
	local serverCount = self:getServerCount()
	local totalPage = math.modf((serverCount-1)/serverPerArea)+1
	if self.curPage == 1 then 	
		local recommendCnt = table.size(self.serverMgr:getRecommendServerList())		
		itemCount = math.modf((recommendCnt-1)/2)+1
	else
		if (serverCount-(self.curPage-1)*serverPerArea)<0 then 
			itemCount = serverCount-(self.curPage-2)*serverPerArea
			itemCount = math.modf((itemCount-1)/2)+1
		else
			itemCount = math.modf((serverPerArea-1)/2)+1
		end				
	end	
	return itemCount
end

function AllServerView:updateServerList()
	self.serverDetailTable:reloadData()
end

--服务器的数量
function AllServerView:getServerCount()
	return table.size(self.serverMgr:getServerList())
end					

function AllServerView:update()
	local bigAreaCount = math.modf((self:getServerCount()-1)/serverPerArea)+1
	self:updateBigArea(bigAreaCount)		
	--self:updateRecentServer(self.serverMgr:getRecentServers(),self.serverMgr:getRecentId())	
	self:updateRecentServer(self.serverMgr:getRecentId())
end
